'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/* eslint-disable no-use-before-define */

var AbstractOption = function () {
  function AbstractOption() {
    _classCallCheck(this, AbstractOption);
  }

  _createClass(AbstractOption, [{
    key: 'get',

    // Abstract
    value: function get() {
      throw new Error('Unimplemented AbstractOption#get');
    }
  }, {
    key: 'map',
    value: function map(f) {
      return this.isEmpty ? none : some(f(this.get()));
    }
  }, {
    key: 'flatMap',
    value: function flatMap(f) {
      return this.isEmpty ? none : f(this.get());
    }
  }, {
    key: 'getOrElse',
    value: function getOrElse(def) {
      return this.isEmpty ? def : this.get();
    }
  }, {
    key: 'getOrElseL',
    value: function getOrElseL(def) {
      return this.isEmpty ? def() : this.get();
    }
  }, {
    key: 'filter',
    value: function filter(p) {
      return this.isEmpty || p(this.get()) ? this : none;
    }
  }]);

  return AbstractOption;
}();

var Some = function (_AbstractOption) {
  _inherits(Some, _AbstractOption);

  function Some(value) {
    _classCallCheck(this, Some);

    var _this = _possibleConstructorReturn(this, (Some.__proto__ || Object.getPrototypeOf(Some)).call(this));

    _this.isEmpty = false;
    _this.nonEmpty = true;

    _this.value = value;
    return _this;
  }

  _createClass(Some, [{
    key: 'get',
    value: function get() {
      return this.value;
    }
  }]);

  return Some;
}(AbstractOption);

var None = function (_AbstractOption2) {
  _inherits(None, _AbstractOption2);

  function None() {
    var _ref;

    var _temp, _this2, _ret;

    _classCallCheck(this, None);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this2 = _possibleConstructorReturn(this, (_ref = None.__proto__ || Object.getPrototypeOf(None)).call.apply(_ref, [this].concat(args))), _this2), _this2.isEmpty = true, _this2.nonEmpty = false, _temp), _possibleConstructorReturn(_this2, _ret);
  }

  _createClass(None, [{
    key: 'get',
    value: function get() {
      throw new Error('Called None.get');
    }
  }]);

  return None;
}(AbstractOption);

var some = exports.some = function some(a) {
  return new Some(a);
};
var none = exports.none = new None();
var of = exports.of = function of(a) {
  return a === null || a === undefined ? none : some(a);
};

exports.default = {
  some: some,
  none: none
};